commit 21076167d7a67dc33ba671ce89b36f1be9ef2e51
Author: Thomas Schöpping <tschoepp@cit-ec.uni-bielefeld.de>
Date:   Mon Feb 4 17:36:52 2019 +0100

    Applied minor enhancements to all drivers.
    Please note: multiple functions should (and will) be moved from the .c sources to the header files as inline functions soon.

diff --git a/source/alld_bq27500.c b/source/alld_bq27500.c
index c2bff3e..aa3cc0f 100644
--- a/source/alld_bq27500.c
+++ b/source/alld_bq27500.c
@@ -61,8 +61,7 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  *
  * @return  The return status indicates whether the function call was succesfull or a timeout occurred.
  */
-inline apalExitStatus_t
-bq27500_lld_read_batlow(const BQ27500Driver* const bq27500, bq27500_lld_batlow_t* const batlow)
+apalExitStatus_t bq27500_lld_read_batlow(const BQ27500Driver* const bq27500, bq27500_lld_batlow_t* const batlow)
 {
   apalDbgAssert(bq27500 != NULL);
   apalDbgAssert(batlow != NULL);
@@ -80,8 +79,7 @@ bq27500_lld_read_batlow(const BQ27500Driver* const bq27500, bq27500_lld_batlow_t
  *
  * @return  The return status indicates whether the function call was succesfull or a timeout occurred.
  */
-inline apalExitStatus_t
-bq27500_lld_read_batgood(const BQ27500Driver* const bq27500, bq27500_lld_batgood_t* const batgood)
+apalExitStatus_t bq27500_lld_read_batgood(const BQ27500Driver* const bq27500, bq27500_lld_batgood_t* const batgood)
 {
   apalDbgAssert(bq27500 != NULL);
   apalDbgAssert(batgood != NULL);
@@ -101,8 +99,7 @@ bq27500_lld_read_batgood(const BQ27500Driver* const bq27500, bq27500_lld_batgood
  *
  * @return  The return status indicates whether the function call was succesfull or a timeout occurred.
  */
-inline apalExitStatus_t
-bq27500_lld_std_command(const BQ27500Driver* const bq27500, const bq27500_lld_std_command_t cmd, uint16_t* const dst, const apalTime_t timeout)
+apalExitStatus_t bq27500_lld_std_command(const BQ27500Driver* const bq27500, const bq27500_lld_std_command_t cmd, uint16_t* const dst, const apalTime_t timeout)
 {
   apalDbgAssert(bq27500 != NULL);
   apalDbgAssert(dst != NULL);
@@ -121,8 +118,7 @@ bq27500_lld_std_command(const BQ27500Driver* const bq27500, const bq27500_lld_st
  *
  * @return  The return status indicates whether the function call was succesfull or a timeout occurred.
  */
-inline apalExitStatus_t
-bq27500_lld_sub_command_call(const BQ27500Driver* const bq27500, const bq27500_lld_control_subcmd_t cmd, const apalTime_t timeout)
+apalExitStatus_t bq27500_lld_sub_command_call(const BQ27500Driver* const bq27500, const bq27500_lld_control_subcmd_t cmd, const apalTime_t timeout)
 {
   apalDbgAssert(bq27500 != NULL);
 
@@ -138,8 +134,7 @@ bq27500_lld_sub_command_call(const BQ27500Driver* const bq27500, const bq27500_l
  *
  * @return  The return status indicates whether the function call was succesfull or a timeout occurred.
  */
-inline apalExitStatus_t
-bq27500_lld_sub_command_read(const BQ27500Driver* const bq27500, uint16_t* const data, const apalTime_t timeout)
+apalExitStatus_t bq27500_lld_sub_command_read(const BQ27500Driver* const bq27500, uint16_t* const data, const apalTime_t timeout)
 {
   apalDbgAssert(bq27500 != NULL);
   apalDbgAssert(data != NULL);
@@ -162,8 +157,7 @@ bq27500_lld_sub_command_read(const BQ27500Driver* const bq27500, uint16_t* const
  *
  * @return  The return status indicates whether the function call was succesfull or a timeout occurred.
  */
-inline apalExitStatus_t
-bq27500_lld_ext_command(const BQ27500Driver* const bq27500, const bq27500_lld_ext_command_t cmd, const bq27500_lld_ext_cmd_access_t rw, uint8_t* const buffer, const uint8_t length, const uint8_t offset, const apalTime_t timeout)
+apalExitStatus_t bq27500_lld_ext_command(const BQ27500Driver* const bq27500, const bq27500_lld_ext_command_t cmd, const bq27500_lld_ext_cmd_access_t rw, uint8_t* const buffer, const uint8_t length, const uint8_t offset, const apalTime_t timeout)
 {
   apalDbgAssert(bq27500 != NULL);
   apalDbgAssert(buffer != NULL);
@@ -186,8 +180,7 @@ bq27500_lld_ext_command(const BQ27500Driver* const bq27500, const bq27500_lld_ex
  *
  * @return  The return status indicates whether the function call was succesfull or a timeout occurred.
  */
-inline apalExitStatus_t
-bq27500_lld_send_ctnl_data(const BQ27500Driver* const bq27500, const uint16_t data, const apalTime_t timeout)
+apalExitStatus_t bq27500_lld_send_ctnl_data(const BQ27500Driver* const bq27500, const uint16_t data, const apalTime_t timeout)
 {
   apalDbgAssert(bq27500 != NULL);
 
@@ -202,8 +195,7 @@ bq27500_lld_send_ctnl_data(const BQ27500Driver* const bq27500, const uint16_t da
  *
  * @return  The return status indicates whether the function call was succesfull or a timeout occurred.
  */
-inline apalExitStatus_t
-bq27500_lld_compute_blockdata_checksum(const uint8_t* const blockdata, uint8_t* const sum)
+apalExitStatus_t bq27500_lld_compute_blockdata_checksum(const uint8_t* const blockdata, uint8_t* const sum)
 {
   apalDbgAssert(blockdata != NULL);
   apalDbgAssert(sum != NULL);