commit 21076167d7a67dc33ba671ce89b36f1be9ef2e51
Author: Thomas Schöpping <tschoepp@cit-ec.uni-bielefeld.de>
Date:   Mon Feb 4 17:36:52 2019 +0100

    Applied minor enhancements to all drivers.
    Please note: multiple functions should (and will) be moved from the .c sources to the header files as inline functions soon.

diff --git a/source/alld_hmc5883l.c b/source/alld_hmc5883l.c
index 3f4393f..b242d7b 100644
--- a/source/alld_hmc5883l.c
+++ b/source/alld_hmc5883l.c
@@ -63,8 +63,7 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  *
  * @return The return status indicates whether the function call was successfull or a timeout occured.
  */
-inline apalExitStatus_t
-hmc5883l_lld_check(const HMC5883LDriver* const hmcd, uint8_t* const rxbuffer, const uint8_t num, const apalTime_t timeout)
+apalExitStatus_t hmc5883l_lld_check(const HMC5883LDriver* const hmcd, uint8_t* const rxbuffer, const uint8_t num, const apalTime_t timeout)
 {
   apalDbgAssert(hmcd != NULL && hmcd->i2cd != NULL);
   apalDbgAssert(rxbuffer != NULL);
@@ -83,8 +82,7 @@ hmc5883l_lld_check(const HMC5883LDriver* const hmcd, uint8_t* const rxbuffer, co
  *
  * @return The return status indicates whether the function call was successfull or a timeout occured.
  */
-inline apalExitStatus_t
-hmc5883l_lld_write_register(const HMC5883LDriver* const hmcd, const hmc5883l_lld_register_t regaddr, const uint8_t* const data, const uint8_t num, const apalTime_t timeout)
+apalExitStatus_t hmc5883l_lld_write_register(const HMC5883LDriver* const hmcd, const hmc5883l_lld_register_t regaddr, const uint8_t* const data, const uint8_t num, const apalTime_t timeout)
 {
   apalDbgAssert(hmcd != NULL && hmcd->i2cd != NULL);
   apalDbgAssert(data != NULL);
@@ -104,8 +102,7 @@ hmc5883l_lld_write_register(const HMC5883LDriver* const hmcd, const hmc5883l_lld
  *
  * @return The return status indicates whether the function call was successfull or a timeout occured.
  */
-inline apalExitStatus_t
-hmc5883l_lld_set_register(const HMC5883LDriver* const hmcd, const hmc5883l_lld_register_t regaddr, const uint8_t data, const apalTime_t timeout)
+apalExitStatus_t hmc5883l_lld_set_register(const HMC5883LDriver* const hmcd, const hmc5883l_lld_register_t regaddr, const uint8_t data, const apalTime_t timeout)
 {
   apalDbgAssert(hmcd != NULL && hmcd->i2cd != NULL);
 
@@ -125,8 +122,7 @@ hmc5883l_lld_set_register(const HMC5883LDriver* const hmcd, const hmc5883l_lld_r
  *
  * @return The return status indicates whether the function call was successfull or a timeout occured.
  */
-inline apalExitStatus_t
-hmc5883l_lld_read_register(const HMC5883LDriver* const hmcd, const hmc5883l_lld_register_t regaddr, uint8_t* const data, const uint8_t num, const apalTime_t timeout)
+apalExitStatus_t hmc5883l_lld_read_register(const HMC5883LDriver* const hmcd, const hmc5883l_lld_register_t regaddr, uint8_t* const data, const uint8_t num, const apalTime_t timeout)
 {
   apalDbgAssert(hmcd != NULL && hmcd->i2cd != NULL);
   apalDbgAssert(data != NULL);
@@ -142,8 +138,7 @@ hmc5883l_lld_read_register(const HMC5883LDriver* const hmcd, const hmc5883l_lld_
  *
  * @return The return status indicates whether the function call was successfull or a timeout occured.
  */
-inline apalExitStatus_t
-hmc5883l_lld_read_data(const HMC5883LDriver* const hmcd, uint16_t* const data, const apalTime_t timeout)
+apalExitStatus_t hmc5883l_lld_read_data(const HMC5883LDriver* const hmcd, uint16_t* const data, const apalTime_t timeout)
 {
   apalDbgAssert(data != NULL);
 
@@ -168,8 +163,7 @@ hmc5883l_lld_read_data(const HMC5883LDriver* const hmcd, uint16_t* const data, c
  *
  * @return The return status indicates whether the function call was successfull or a timeout occured.
  */
-inline apalExitStatus_t
-hmc5883l_lld_read_status(const HMC5883LDriver* const hmcd, uint8_t* const status, const apalTime_t timeout)
+apalExitStatus_t hmc5883l_lld_read_status(const HMC5883LDriver* const hmcd, uint8_t* const status, const apalTime_t timeout)
 {
   apalDbgAssert(status != NULL);
 
@@ -184,8 +178,7 @@ hmc5883l_lld_read_status(const HMC5883LDriver* const hmcd, uint8_t* const status
  *
  * @return The return status indicates whether the function call was successfull or a timeout occured.
  */
-inline apalExitStatus_t
-hmc5883l_lld_read_config(const HMC5883LDriver* const hmcd, hmc5883l_lld_config_t* const cfg, const apalTime_t timeout)
+apalExitStatus_t hmc5883l_lld_read_config(const HMC5883LDriver* const hmcd, hmc5883l_lld_config_t* const cfg, const apalTime_t timeout)
 {
   apalDbgAssert(cfg != NULL);
 
@@ -208,8 +201,7 @@ hmc5883l_lld_read_config(const HMC5883LDriver* const hmcd, hmc5883l_lld_config_t
  *
  * @return The return status indicates whether the function call was successfull or a timeout occured.
  */
-inline apalExitStatus_t
-hmc5883l_lld_write_config(const HMC5883LDriver* const hmcd, const hmc5883l_lld_config_t cfg, const apalTime_t timeout)
+apalExitStatus_t hmc5883l_lld_write_config(const HMC5883LDriver* const hmcd, const hmc5883l_lld_config_t cfg, const apalTime_t timeout)
 {
   uint8_t conf[3];
   conf[0] = cfg.avg | cfg.outrate | cfg.mbias;
@@ -226,8 +218,7 @@ hmc5883l_lld_write_config(const HMC5883LDriver* const hmcd, const hmc5883l_lld_c
  *
  * @return The return status indicates whether the function call was successfull or a timeout occured.
  */
-inline apalExitStatus_t
-hmc5883l_lld_read_lock(const HMC5883LDriver* const hmcd, uint8_t* const lock, const apalTime_t timeout)
+apalExitStatus_t hmc5883l_lld_read_lock(const HMC5883LDriver* const hmcd, uint8_t* const lock, const apalTime_t timeout)
 {
   apalDbgAssert(lock != NULL);
 
@@ -244,8 +235,7 @@ hmc5883l_lld_read_lock(const HMC5883LDriver* const hmcd, uint8_t* const lock, co
  *
  * @return The return status indicates whether the function call was successfull or a timeout occured.
  */
-inline apalExitStatus_t
-hmc5883l_lld_read_rdy(const HMC5883LDriver* const hmcd, uint8_t* const rdy, const apalTime_t timeout)
+apalExitStatus_t hmc5883l_lld_read_rdy(const HMC5883LDriver* const hmcd, uint8_t* const rdy, const apalTime_t timeout)
 {
   apalDbgAssert(rdy != NULL);
 