commit 21076167d7a67dc33ba671ce89b36f1be9ef2e51
Author: Thomas Schöpping <tschoepp@cit-ec.uni-bielefeld.de>
Date:   Mon Feb 4 17:36:52 2019 +0100

    Applied minor enhancements to all drivers.
    Please note: multiple functions should (and will) be moved from the .c sources to the header files as inline functions soon.

diff --git a/source/alld_ina219.c b/source/alld_ina219.c
index fd1cd73..435ce6c 100644
--- a/source/alld_ina219.c
+++ b/source/alld_ina219.c
@@ -62,8 +62,7 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  * @param[in]   timeout     timeout
  * @return                  An indicator whether the call was successfull
  */
-inline apalExitStatus_t
-ina219_lld_read_register(const INA219Driver* const ina219, const ina219_lld_register_t addr, uint16_t* const data, const uint8_t num, const apalTime_t timeout)
+apalExitStatus_t ina219_lld_read_register(const INA219Driver* const ina219, const ina219_lld_register_t addr, uint16_t* const data, const uint8_t num, const apalTime_t timeout)
 {
   apalDbgAssert(ina219 != NULL);
   apalDbgAssert(ina219->i2cd != NULL);
@@ -87,8 +86,7 @@ ina219_lld_read_register(const INA219Driver* const ina219, const ina219_lld_regi
  * @param[in]   timeout     timeout
  * @return                  An indicator whether the call was successfull
  */
-inline apalExitStatus_t
-ina219_lld_write_register(const INA219Driver* const ina219, const ina219_lld_register_t addr, const uint16_t* const data, const uint8_t num, const apalTime_t timeout)
+apalExitStatus_t ina219_lld_write_register(const INA219Driver* const ina219, const ina219_lld_register_t addr, const uint16_t* const data, const uint8_t num, const apalTime_t timeout)
 {
   apalDbgAssert(ina219 != NULL);
   apalDbgAssert(ina219->i2cd != NULL);
@@ -112,8 +110,7 @@ ina219_lld_write_register(const INA219Driver* const ina219, const ina219_lld_reg
  * @param[in]   timeout     timeout
  * @return                  An indicator whether the call was successfull
  */
-inline apalExitStatus_t
-ina219_lld_calibration(INA219Driver* const ina219, const ina219_lld_calib_input_t* const calib_in, ina219_lld_calib_output_t* const calib_out)
+apalExitStatus_t ina219_lld_calibration(INA219Driver* const ina219, const ina219_lld_calib_input_t* const calib_in, ina219_lld_calib_output_t* const calib_out)
 {
   apalDbgAssert(ina219 != NULL);
   apalDbgAssert(calib_in != NULL);
@@ -168,8 +165,7 @@ ina219_lld_calibration(INA219Driver* const ina219, const ina219_lld_calib_input_
  * @param[in]   timeout     timeout
  * @return                  An indicator whether the call was successfull
  */
-inline apalExitStatus_t
-ina219_lld_read_config(const INA219Driver* const ina219, ina219_lld_cfg_t* const cfg, const apalTime_t timeout)
+apalExitStatus_t ina219_lld_read_config(const INA219Driver* const ina219, ina219_lld_cfg_t* const cfg, const apalTime_t timeout)
 {
   apalDbgAssert(ina219 != NULL);
   apalDbgAssert(cfg != NULL);
@@ -185,8 +181,7 @@ ina219_lld_read_config(const INA219Driver* const ina219, ina219_lld_cfg_t* const
  * @param[in]   timeout     timeout
  * @return                  An indicator whether the call was successfull
  */
-inline apalExitStatus_t
-ina219_lld_write_config(const INA219Driver* const ina219, ina219_lld_cfg_t cfg, const apalTime_t timeout)
+apalExitStatus_t ina219_lld_write_config(const INA219Driver* const ina219, ina219_lld_cfg_t cfg, const apalTime_t timeout)
 {
   apalDbgAssert(ina219 != NULL);
 
@@ -201,8 +196,7 @@ ina219_lld_write_config(const INA219Driver* const ina219, ina219_lld_cfg_t cfg,
  * @param[in]   timeout     timeout
  * @return                  An indicator whether the call was successfull
  */
-inline apalExitStatus_t
-ina219_lld_read_calibration(const INA219Driver* const ina219, uint16_t* const calib, const apalTime_t timeout)
+apalExitStatus_t ina219_lld_read_calibration(const INA219Driver* const ina219, uint16_t* const calib, const apalTime_t timeout)
 {
   apalDbgAssert(ina219 != NULL);
   apalDbgAssert(calib != NULL);
@@ -218,8 +212,7 @@ ina219_lld_read_calibration(const INA219Driver* const ina219, uint16_t* const ca
  * @param[in]   timeout     timeout
  * @return                  An indicator whether the call was successfull
  */
-inline apalExitStatus_t
-ina219_lld_write_calibration(const INA219Driver* const ina219, const uint16_t calib, const apalTime_t timeout)
+apalExitStatus_t ina219_lld_write_calibration(const INA219Driver* const ina219, const uint16_t calib, const apalTime_t timeout)
 {
   apalDbgAssert(ina219 != NULL);
 
@@ -233,8 +226,7 @@ ina219_lld_write_calibration(const INA219Driver* const ina219, const uint16_t ca
  * @param[in]   timeout     timeout
  * @return                  An indicator whether the call was successfull
  */
-inline apalExitStatus_t
-ina219_lld_reset(const INA219Driver* const ina219, const apalTime_t timeout)
+apalExitStatus_t ina219_lld_reset(const INA219Driver* const ina219, const apalTime_t timeout)
 {
   apalDbgAssert(ina219 != NULL);
 
@@ -250,8 +242,7 @@ ina219_lld_reset(const INA219Driver* const ina219, const apalTime_t timeout)
  * @param[in]   timeout     timeout
  * @return                  An indicator whether the call was successfull
  */
-inline apalExitStatus_t
-ina219_lld_read_shunt_voltage(const INA219Driver* const ina219, int32_t* const data, const apalTime_t timeout)
+apalExitStatus_t ina219_lld_read_shunt_voltage(const INA219Driver* const ina219, int32_t* const data, const apalTime_t timeout)
 {
   apalDbgAssert(ina219 != NULL);
   apalDbgAssert(data != NULL);
@@ -285,8 +276,7 @@ ina219_lld_read_shunt_voltage(const INA219Driver* const ina219, int32_t* const d
  * @param[in]   timeout     timeout
  * @return                  An indicator whether the call was successfull
  */
-inline apalExitStatus_t
-ina219_lld_read_bus_voltage(const INA219Driver* const ina219, uint32_t* const data, const apalTime_t timeout)
+apalExitStatus_t ina219_lld_read_bus_voltage(const INA219Driver* const ina219, uint32_t* const data, const apalTime_t timeout)
 {
   apalDbgAssert(ina219 != NULL);
   apalDbgAssert(data != NULL);
@@ -308,8 +298,7 @@ ina219_lld_read_bus_voltage(const INA219Driver* const ina219, uint32_t* const da
  * @param[in]   timeout     timeout
  * @return                  An indicator whether the call was successfull
  */
-inline apalExitStatus_t
-ina219_lld_read_power(const INA219Driver* const ina219, uint32_t* const data, const apalTime_t timeout)
+apalExitStatus_t ina219_lld_read_power(const INA219Driver* const ina219, uint32_t* const data, const apalTime_t timeout)
 {
   apalDbgAssert(ina219 != NULL);
   apalDbgAssert(data != NULL);
@@ -328,8 +317,7 @@ ina219_lld_read_power(const INA219Driver* const ina219, uint32_t* const data, co
  * @param[in]   timeout     timeout
  * @return                  An indicator whether the call was successfull
  */
-inline apalExitStatus_t
-ina219_lld_read_current(const INA219Driver* const ina219, int16_t* const data, const apalTime_t timeout)
+apalExitStatus_t ina219_lld_read_current(const INA219Driver* const ina219, int16_t* const data, const apalTime_t timeout)
 {
   apalDbgAssert(ina219 != NULL);
   apalDbgAssert(data != NULL);
@@ -348,8 +336,7 @@ ina219_lld_read_current(const INA219Driver* const ina219, int16_t* const data, c
  * @param[in]   timeout     timeout
  * @return                  An indicator whether the call was successfull
  */
-inline apalExitStatus_t
-ina219_lld_bus_conversion_ready(const INA219Driver* const ina219, uint16_t* const buscnv, const apalTime_t timeout)
+apalExitStatus_t ina219_lld_bus_conversion_ready(const INA219Driver* const ina219, uint16_t* const buscnv, const apalTime_t timeout)
 {
   apalDbgAssert(ina219 != NULL);
   apalDbgAssert(buscnv != NULL);