commit 21076167d7a67dc33ba671ce89b36f1be9ef2e51
Author: Thomas Schöpping <tschoepp@cit-ec.uni-bielefeld.de>
Date:   Mon Feb 4 17:36:52 2019 +0100

    Applied minor enhancements to all drivers.
    Please note: multiple functions should (and will) be moved from the .c sources to the header files as inline functions soon.

diff --git a/source/alld_l3g4200d.c b/source/alld_l3g4200d.c
index 1743d23..945738b 100644
--- a/source/alld_l3g4200d.c
+++ b/source/alld_l3g4200d.c
@@ -63,8 +63,7 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  *
  * @return  The return status indicates whether the function call was succesfull or a timeout occurred.
  */
-inline apalExitStatus_t
-l3g4200d_lld_read_register(const L3G4200DDriver* const l3gd, const l3g4200d_lld_register_t regaddr, uint8_t* const data, const uint8_t length)
+apalExitStatus_t l3g4200d_lld_read_register(const L3G4200DDriver* const l3gd, const l3g4200d_lld_register_t regaddr, uint8_t* const data, const uint8_t length)
 {
   apalDbgAssert(l3gd != NULL && l3gd->spid != NULL);
   apalDbgAssert(data != NULL);
@@ -85,8 +84,7 @@ l3g4200d_lld_read_register(const L3G4200DDriver* const l3gd, const l3g4200d_lld_
  *
  * @return  The return status indicates whether the function call was succesfull or a timeout occurred.
  */
-inline apalExitStatus_t
-l3g4200d_lld_write_register(const L3G4200DDriver* const l3gd, const l3g4200d_lld_register_t regaddr, const uint8_t* const data, const uint8_t length)
+apalExitStatus_t l3g4200d_lld_write_register(const L3G4200DDriver* const l3gd, const l3g4200d_lld_register_t regaddr, const uint8_t* const data, const uint8_t length)
 {
   apalDbgAssert(l3gd != NULL && l3gd->spid != NULL);
   apalDbgAssert(data != NULL);
@@ -105,8 +103,7 @@ l3g4200d_lld_write_register(const L3G4200DDriver* const l3gd, const l3g4200d_lld
  *
  * @return  The return status indicates whether the function call was succesfull or a timeout occurred.
  */
-inline apalExitStatus_t
-l3g4200d_lld_read_all_data(const L3G4200DDriver* const l3gd, int16_t* const data, const l3g4200d_lld_cfg_t* const cfg)
+apalExitStatus_t l3g4200d_lld_read_all_data(const L3G4200DDriver* const l3gd, int16_t* const data, const l3g4200d_lld_cfg_t* const cfg)
 {
   apalDbgAssert(data != NULL);
   apalDbgAssert(cfg != NULL);
@@ -134,8 +131,7 @@ l3g4200d_lld_read_all_data(const L3G4200DDriver* const l3gd, int16_t* const data
  *
  * @return  The return status indicates whether the function call was succesfull or a timeout occurred.
  */
-inline apalExitStatus_t
-l3g4200d_lld_read_data(const L3G4200DDriver* const l3gd, int16_t* const data, const l3g4200d_lld_axis_t axis, const l3g4200d_lld_cfg_t* const cfg)
+apalExitStatus_t l3g4200d_lld_read_data(const L3G4200DDriver* const l3gd, int16_t* const data, const l3g4200d_lld_axis_t axis, const l3g4200d_lld_cfg_t* const cfg)
 {
   apalDbgAssert(data != NULL);
   apalDbgAssert(cfg != NULL);
@@ -171,8 +167,7 @@ l3g4200d_lld_read_data(const L3G4200DDriver* const l3gd, int16_t* const data, co
  *
  * @return  The return status indicates whether the function call was succesfull or a timeout occurred.
  */
-inline apalExitStatus_t
-l3g4200d_lld_read_config(const L3G4200DDriver* const l3gd, l3g4200d_lld_cfg_t* const cfg)
+apalExitStatus_t l3g4200d_lld_read_config(const L3G4200DDriver* const l3gd, l3g4200d_lld_cfg_t* const cfg)
 {
   apalDbgAssert(cfg != NULL);
 
@@ -186,8 +181,7 @@ l3g4200d_lld_read_config(const L3G4200DDriver* const l3gd, l3g4200d_lld_cfg_t* c
  *
  * @return  The return status indicates whether the function call was succesfull or a timeout occurred.
  */
-inline apalExitStatus_t
-l3g4200d_lld_write_config(const L3G4200DDriver* const l3gd, const l3g4200d_lld_cfg_t cfg)
+apalExitStatus_t l3g4200d_lld_write_config(const L3G4200DDriver* const l3gd, const l3g4200d_lld_cfg_t cfg)
 {
   return l3g4200d_lld_write_register(l3gd, L3G4200D_LLD_REGISTER_CTRL_REG1, cfg.data, 5);
 }
@@ -199,8 +193,7 @@ l3g4200d_lld_write_config(const L3G4200DDriver* const l3gd, const l3g4200d_lld_c
  *
  * @return  The return status indicates whether the function call was succesfull or a timeout occurred.
  */
-inline apalExitStatus_t
-l3g4200d_lld_read_int_config(const L3G4200DDriver* const l3gd, l3g4200d_lld_int_cfg_t* const cfg)
+apalExitStatus_t l3g4200d_lld_read_int_config(const L3G4200DDriver* const l3gd, l3g4200d_lld_int_cfg_t* const cfg)
 {
   apalDbgAssert(cfg != NULL);
 
@@ -214,8 +207,7 @@ l3g4200d_lld_read_int_config(const L3G4200DDriver* const l3gd, l3g4200d_lld_int_
  *
  * @return  The return status indicates whether the function call was succesfull or a timeout occurred.
  */
-inline apalExitStatus_t
-l3g4200d_lld_write_int_config(const L3G4200DDriver* const l3gd, const l3g4200d_lld_int_cfg_t cfg)
+apalExitStatus_t l3g4200d_lld_write_int_config(const L3G4200DDriver* const l3gd, const l3g4200d_lld_int_cfg_t cfg)
 {
   apalExitStatus_t status = l3g4200d_lld_write_register(l3gd, L3G4200D_LLD_REGISTER_INT1_CFG, cfg.data, 1);
   if (status != APAL_STATUS_OK) {
@@ -231,8 +223,7 @@ l3g4200d_lld_write_int_config(const L3G4200DDriver* const l3gd, const l3g4200d_l
  *
  * @return  The return status indicates whether the function call was succesfull or a timeout occurred.
  */
-inline apalExitStatus_t
-l3g4200d_lld_read_status_register(const L3G4200DDriver* const l3gd, uint8_t* const status)
+apalExitStatus_t l3g4200d_lld_read_status_register(const L3G4200DDriver* const l3gd, uint8_t* const status)
 {
   apalDbgAssert(status != NULL);
 
@@ -261,8 +252,7 @@ l3g4200d_lld_read_fifo_ctrl_register(const L3G4200DDriver* const l3gd, uint8_t*
  *
  * @return  The return status indicates whether the function call was succesfull or a timeout occurred.
  */
-inline apalExitStatus_t
-l3g4200d_lld_write_fifo_ctrl_register(const L3G4200DDriver* const l3gd, const uint8_t fifo)
+apalExitStatus_t l3g4200d_lld_write_fifo_ctrl_register(const L3G4200DDriver* const l3gd, const uint8_t fifo)
 {
   return l3g4200d_lld_write_register(l3gd, L3G4200D_LLD_REGISTER_FIFO_CTRL_REG, &fifo, 1);
 }
@@ -274,8 +264,7 @@ l3g4200d_lld_write_fifo_ctrl_register(const L3G4200DDriver* const l3gd, const ui
  *
  * @return  The return status indicates whether the function call was succesfull or a timeout occurred.
  */
-inline apalExitStatus_t
-l3g4200d_lld_read_fifo_src_register(const L3G4200DDriver* const l3gd, uint8_t* const fifo)
+apalExitStatus_t l3g4200d_lld_read_fifo_src_register(const L3G4200DDriver* const l3gd, uint8_t* const fifo)
 {
   apalDbgAssert(fifo != NULL);
 
@@ -289,8 +278,7 @@ l3g4200d_lld_read_fifo_src_register(const L3G4200DDriver* const l3gd, uint8_t* c
  *
  * @return  The return status indicates whether the function call was succesfull or a timeout occurred.
  */
-inline apalExitStatus_t
-l3g4200d_lld_read_int_src(const L3G4200DDriver* const l3gd, uint8_t* const cfg)
+apalExitStatus_t l3g4200d_lld_read_int_src(const L3G4200DDriver* const l3gd, uint8_t* const cfg)
 {
   apalDbgAssert(cfg != NULL);
 