commit 21076167d7a67dc33ba671ce89b36f1be9ef2e51
Author: Thomas Schöpping <tschoepp@cit-ec.uni-bielefeld.de>
Date:   Mon Feb 4 17:36:52 2019 +0100

    Applied minor enhancements to all drivers.
    Please note: multiple functions should (and will) be moved from the .c sources to the header files as inline functions soon.

diff --git a/source/alld_lis331dlh.c b/source/alld_lis331dlh.c
index 7917c72..35ce37e 100644
--- a/source/alld_lis331dlh.c
+++ b/source/alld_lis331dlh.c
@@ -63,8 +63,7 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  *
  * @return  The return status indicates whether the function call was succesfull or a timeout occurred.
  */
-inline apalExitStatus_t
-lis331dlh_lld_read_register(const LIS331DLHDriver* const lisd, const lis331dlh_lld_register_t regaddr, uint8_t *data, const uint8_t length)
+apalExitStatus_t lis331dlh_lld_read_register(const LIS331DLHDriver* const lisd, const lis331dlh_lld_register_t regaddr, uint8_t *data, const uint8_t length)
 {
   apalDbgAssert(lisd != NULL && lisd->spid != NULL);
   apalDbgAssert(data != NULL);
@@ -85,8 +84,7 @@ lis331dlh_lld_read_register(const LIS331DLHDriver* const lisd, const lis331dlh_l
  *
  * @return  The return status indicates whether the function call was succesfull or a timeout occurred.
  */
-inline apalExitStatus_t
-lis331dlh_lld_write_register(const LIS331DLHDriver* const lisd, const lis331dlh_lld_register_t regaddr, const uint8_t *data, const uint8_t length)
+apalExitStatus_t lis331dlh_lld_write_register(const LIS331DLHDriver* const lisd, const lis331dlh_lld_register_t regaddr, const uint8_t *data, const uint8_t length)
 {
   apalDbgAssert(lisd != NULL && lisd->spid != NULL);
   apalDbgAssert(data != NULL);
@@ -103,8 +101,7 @@ lis331dlh_lld_write_register(const LIS331DLHDriver* const lisd, const lis331dlh_
  *
  * @return  The return status indicates whether the function call was succesfull or a timeout occurred.
  */
-inline apalExitStatus_t
-lis331dlh_lld_reset_hp_filter(const LIS331DLHDriver* const lisd)
+apalExitStatus_t lis331dlh_lld_reset_hp_filter(const LIS331DLHDriver* const lisd)
 {
   return lis331dlh_lld_read_register(lisd, LIS331DLH_LLD_REGISTER_HP_FILTER_RESET, NULL, 0);
 }
@@ -117,8 +114,7 @@ lis331dlh_lld_reset_hp_filter(const LIS331DLHDriver* const lisd)
  *
  * @return  The return status indicates whether the function call was succesfull or a timeout occurred.
  */
-inline apalExitStatus_t
-lis331dlh_lld_read_all_data(const LIS331DLHDriver* const lisd, int16_t *data, const lis331dlh_lld_cfg_t *cfg)
+apalExitStatus_t lis331dlh_lld_read_all_data(const LIS331DLHDriver* const lisd, int16_t *data, const lis331dlh_lld_cfg_t *cfg)
 {
   apalDbgAssert(data != NULL);
   apalDbgAssert(cfg != NULL);
@@ -146,8 +142,7 @@ lis331dlh_lld_read_all_data(const LIS331DLHDriver* const lisd, int16_t *data, co
  *
  * @return  The return status indicates whether the function call was succesfull or a timeout occurred.
  */
-inline apalExitStatus_t
-lis331dlh_lld_read_data(const LIS331DLHDriver* const lisd, int16_t *data, const lis331dlh_lld_axis_t axis, const lis331dlh_lld_cfg_t *cfg)
+apalExitStatus_t lis331dlh_lld_read_data(const LIS331DLHDriver* const lisd, int16_t *data, const lis331dlh_lld_axis_t axis, const lis331dlh_lld_cfg_t *cfg)
 {
   apalDbgAssert(data != NULL);
   apalDbgAssert(cfg != NULL);
@@ -183,8 +178,7 @@ lis331dlh_lld_read_data(const LIS331DLHDriver* const lisd, int16_t *data, const
  *
  * @return  The return status indicates whether the function call was succesfull or a timeout occurred.
  */
-inline apalExitStatus_t
-lis331dlh_lld_read_config(const LIS331DLHDriver* const lisd, lis331dlh_lld_cfg_t *cfg)
+apalExitStatus_t lis331dlh_lld_read_config(const LIS331DLHDriver* const lisd, lis331dlh_lld_cfg_t *cfg)
 {
   apalDbgAssert(cfg != NULL);
 
@@ -198,8 +192,7 @@ lis331dlh_lld_read_config(const LIS331DLHDriver* const lisd, lis331dlh_lld_cfg_t
  *
  * @return  The return status indicates whether the function call was succesfull or a timeout occurred.
  */
-inline apalExitStatus_t
-lis331dlh_lld_write_config(const LIS331DLHDriver* const lisd, const lis331dlh_lld_cfg_t *cfg)
+apalExitStatus_t lis331dlh_lld_write_config(const LIS331DLHDriver* const lisd, const lis331dlh_lld_cfg_t *cfg)
 {
   apalDbgAssert(cfg != NULL);
 
@@ -214,8 +207,7 @@ lis331dlh_lld_write_config(const LIS331DLHDriver* const lisd, const lis331dlh_ll
  *
  * @return  The return status indicates whether the function call was succesfull or a timeout occurred.
  */
-inline apalExitStatus_t
-lis331dlh_lld_read_int_config(const LIS331DLHDriver* const lisd, lis331dlh_lld_int_cfg_t *cfg, const lis331dlh_lld_int_t interrupt)
+apalExitStatus_t lis331dlh_lld_read_int_config(const LIS331DLHDriver* const lisd, lis331dlh_lld_int_cfg_t *cfg, const lis331dlh_lld_int_t interrupt)
 {
   apalDbgAssert(cfg != NULL);
 
@@ -244,8 +236,7 @@ lis331dlh_lld_read_int_config(const LIS331DLHDriver* const lisd, lis331dlh_lld_i
  *
  * @return  The return status indicates whether the function call was succesfull or a timeout occurred.
  */
-inline apalExitStatus_t
-lis331dlh_lld_write_int_config(const LIS331DLHDriver* const lisd, const lis331dlh_lld_int_cfg_t *cfg, const lis331dlh_lld_int_t interrupt)
+apalExitStatus_t lis331dlh_lld_write_int_config(const LIS331DLHDriver* const lisd, const lis331dlh_lld_int_cfg_t *cfg, const lis331dlh_lld_int_t interrupt)
 {
   apalDbgAssert(cfg != NULL);
 
@@ -270,8 +261,7 @@ lis331dlh_lld_write_int_config(const LIS331DLHDriver* const lisd, const lis331dl
  *
  * @return  The return status indicates whether the function call was succesfull or a timeout occurred.
  */
-inline apalExitStatus_t
-lis331dlh_lld_read_status_register(const LIS331DLHDriver* const lisd, uint8_t *status)
+apalExitStatus_t lis331dlh_lld_read_status_register(const LIS331DLHDriver* const lisd, uint8_t *status)
 {
   apalDbgAssert(status != NULL);
 