commit 21076167d7a67dc33ba671ce89b36f1be9ef2e51
Author: Thomas Schöpping <tschoepp@cit-ec.uni-bielefeld.de>
Date:   Mon Feb 4 17:36:52 2019 +0100

    Applied minor enhancements to all drivers.
    Please note: multiple functions should (and will) be moved from the .c sources to the header files as inline functions soon.

diff --git a/source/alld_mpr121.c b/source/alld_mpr121.c
index 1ae2245..324be6e 100644
--- a/source/alld_mpr121.c
+++ b/source/alld_mpr121.c
@@ -65,8 +65,7 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  *
  * @return  The return status indicates whether the function call was succesfull or a timeout occurred.
  */
-inline apalExitStatus_t
-mpr121_lld_read_register(const MPR121Driver* const mprd, const mpr121_lld_register_t regaddr, const uint8_t offset, const uint8_t size, uint8_t* const data, const apalTime_t timeout)
+apalExitStatus_t mpr121_lld_read_register(const MPR121Driver* const mprd, const mpr121_lld_register_t regaddr, const uint8_t offset, const uint8_t size, uint8_t* const data, const apalTime_t timeout)
 {
   apalDbgAssert(mprd != NULL && mprd->i2cd != NULL);
   apalDbgAssert(data != NULL);
@@ -86,8 +85,7 @@ mpr121_lld_read_register(const MPR121Driver* const mprd, const mpr121_lld_regist
  *
  * @return  The return status indicates whether the function call was succesfull or a timeout occurred.
  */
-inline apalExitStatus_t
-mpr121_lld_write_register(const MPR121Driver* const mprd, const mpr121_lld_register_t regaddr, const uint8_t offset, const uint8_t size, const uint8_t* const data, const apalTime_t timeout)
+apalExitStatus_t mpr121_lld_write_register(const MPR121Driver* const mprd, const mpr121_lld_register_t regaddr, const uint8_t offset, const uint8_t size, const uint8_t* const data, const apalTime_t timeout)
 {
   apalDbgAssert(mprd != NULL && mprd->i2cd != NULL);
   apalDbgAssert(data != NULL);
@@ -105,8 +103,7 @@ mpr121_lld_write_register(const MPR121Driver* const mprd, const mpr121_lld_regis
  *
  * @return  The return status indicates whether the function call was succesfull or a timeout occurred.
  */
-inline apalExitStatus_t
-mpr121_lld_soft_reset(const MPR121Driver* const mprd, const  apalTime_t timeout)
+apalExitStatus_t mpr121_lld_soft_reset(const MPR121Driver* const mprd, const  apalTime_t timeout)
 {
   apalDbgAssert(mprd != NULL && mprd->i2cd != NULL);
 
@@ -124,8 +121,7 @@ mpr121_lld_soft_reset(const MPR121Driver* const mprd, const  apalTime_t timeout)
  *
  * @return  The return status indicates whether the function call was succesfull or a timeout occurred.
  */
-inline apalExitStatus_t
-mpr121_lld_read_filtered_data(const MPR121Driver* const mprd, const uint8_t index, const uint8_t num, uint16_t* const data, const apalTime_t timeout)
+apalExitStatus_t mpr121_lld_read_filtered_data(const MPR121Driver* const mprd, const uint8_t index, const uint8_t num, uint16_t* const data, const apalTime_t timeout)
 {
   apalDbgAssert(data != NULL);
 
@@ -147,8 +143,7 @@ mpr121_lld_read_filtered_data(const MPR121Driver* const mprd, const uint8_t inde
  *
  * @return  The return status indicates whether the function call was succesfull or a timeout occurred.
  */
-inline apalExitStatus_t
-mpr121_lld_read_baseline_data(const MPR121Driver* const mprd, const uint8_t index, const uint8_t num, uint8_t* const data, const apalTime_t timeout)
+apalExitStatus_t mpr121_lld_read_baseline_data(const MPR121Driver* const mprd, const uint8_t index, const uint8_t num, uint8_t* const data, const apalTime_t timeout)
 {
   return mpr121_lld_read_register(mprd, MPR121_LLD_REGISTER_BASELINE, index, num, data, timeout);
 }
@@ -163,8 +158,7 @@ mpr121_lld_read_baseline_data(const MPR121Driver* const mprd, const uint8_t inde
  *
  * @return  The return status indicates whether the function call was succesfull or a timeout occurred.
  */
-inline apalExitStatus_t
-mpr121_lld_read_electrode_data(const MPR121Driver* const mprd, const uint8_t index, const uint8_t num, uint8_t* const data, const apalTime_t timeout)
+apalExitStatus_t mpr121_lld_read_electrode_data(const MPR121Driver* const mprd, const uint8_t index, const uint8_t num, uint8_t* const data, const apalTime_t timeout)
 {
   return mpr121_lld_read_register(mprd, MPR121_LLD_REGISTER_ELE_CURRENT, index, num, data, timeout);
 }
@@ -177,8 +171,7 @@ mpr121_lld_read_electrode_data(const MPR121Driver* const mprd, const uint8_t ind
  *
  * @return  The return status indicates whether the function call was succesfull or a timeout occurred.
  */
-inline apalExitStatus_t
-mpr121_lld_write_config(const MPR121Driver* const mprd, const mpr121_lld_config_t cfg, const apalTime_t timeout)
+apalExitStatus_t mpr121_lld_write_config(const MPR121Driver* const mprd, const mpr121_lld_config_t cfg, const apalTime_t timeout)
 {
   const apalExitStatus_t status = mpr121_lld_write_register(mprd, MPR121_LLD_REGISTER_AUTOCFG_CTRL_0, 0, 5, cfg.values, timeout);
   if (status != APAL_STATUS_OK) {
@@ -196,8 +189,7 @@ mpr121_lld_write_config(const MPR121Driver* const mprd, const mpr121_lld_config_
  *
  * @return  The return status indicates whether the function call was succesfull or a timeout occurred.
  */
-inline apalExitStatus_t
-mpr121_lld_read_config(const MPR121Driver* const mprd, mpr121_lld_config_t* const cfg, const apalTime_t timeout)
+apalExitStatus_t mpr121_lld_read_config(const MPR121Driver* const mprd, mpr121_lld_config_t* const cfg, const apalTime_t timeout)
 {
   const apalExitStatus_t status = mpr121_lld_read_register(mprd, MPR121_LLD_REGISTER_AUTOCFG_CTRL_0, 0, 5, cfg->values, timeout);
   if (status != APAL_STATUS_OK) {