commit 21076167d7a67dc33ba671ce89b36f1be9ef2e51
Author: Thomas Schöpping <tschoepp@cit-ec.uni-bielefeld.de>
Date:   Mon Feb 4 17:36:52 2019 +0100

    Applied minor enhancements to all drivers.
    Please note: multiple functions should (and will) be moved from the .c sources to the header files as inline functions soon.

diff --git a/source/alld_pcal6524.c b/source/alld_pcal6524.c
index 8acd682..a04a673 100644
--- a/source/alld_pcal6524.c
+++ b/source/alld_pcal6524.c
@@ -34,7 +34,7 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
 /* LOCAL DEFINITIONS                                                          */
 /******************************************************************************/
 
-#define _MAXIMUM_GROUP_SIZE           6
+#define _MAXIMUM_GROUP_SIZE                     6
 
 /******************************************************************************/
 /* EXPORTED VARIABLES                                                         */
@@ -63,7 +63,7 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  *
  * @return    The size of the group in bytes.
  */
-inline uint8_t pcal6524_lld_cmd_groupsize(const pcal6524_lld_cmd_t cmd)
+uint8_t pcal6524_lld_cmd_groupsize(const pcal6524_lld_cmd_t cmd)
 {
   switch (cmd) {
     case PCAL6524_LLD_CMD_OUTPUTCONFIGURATION:
@@ -142,8 +142,7 @@ inline uint8_t pcal6524_lld_cmd_groupsize(const pcal6524_lld_cmd_t cmd)
 // *
 // * @return    Indicator whether the function call was successful or a timeout occurred.
 // */
-//inline apalExitStatus_t
-//pcal6524_lld_read_id(const PCAL6524Driver* const pcal6524d, pcal6524_lld_deviceid_t* const info, const apalTime_t timeout)
+//apalExitStatus_t pcal6524_lld_read_id(const PCAL6524Driver* const pcal6524d, pcal6524_lld_deviceid_t* const info, const apalTime_t timeout)
 //{
 //  apalDbgAssert(pcal6524d != NULL && pcal6524d->i2cd != NULL);
 //  apalDbgAssert(info != NULL);
@@ -162,8 +161,7 @@ inline uint8_t pcal6524_lld_cmd_groupsize(const pcal6524_lld_cmd_t cmd)
  *
  * @return    Indicator whether the function call was successful or a timeout occurred.
  */
-inline apalExitStatus_t
-pcal6524_lld_read_reg(const PCAL6524Driver* const pcal6524d, const pcal6524_lld_cmd_t reg, uint8_t* const data, const apalTime_t timeout)
+apalExitStatus_t pcal6524_lld_read_reg(const PCAL6524Driver* const pcal6524d, const pcal6524_lld_cmd_t reg, uint8_t* const data, const apalTime_t timeout)
 {
   apalDbgAssert(pcal6524d != NULL && pcal6524d->i2cd != NULL);
   apalDbgAssert(data != NULL);
@@ -182,8 +180,7 @@ pcal6524_lld_read_reg(const PCAL6524Driver* const pcal6524d, const pcal6524_lld_
  *
  * @return    Indicator whether the function call was successful or a timeout occurred.
  */
-inline apalExitStatus_t
-pcal6524_lld_write_reg(const PCAL6524Driver* const pcal6524d, const pcal6524_lld_cmd_t reg, const uint8_t data, const apalTime_t timeout)
+apalExitStatus_t pcal6524_lld_write_reg(const PCAL6524Driver* const pcal6524d, const pcal6524_lld_cmd_t reg, const uint8_t data, const apalTime_t timeout)
 {
   apalDbgAssert(pcal6524d != NULL && pcal6524d->i2cd != NULL);
 
@@ -202,8 +199,7 @@ pcal6524_lld_write_reg(const PCAL6524Driver* const pcal6524d, const pcal6524_lld
  *
  * @return    Indicator whether the function call was successful or a timeout occurred.
  */
-inline apalExitStatus_t
-pcal6524_lld_read_group(const PCAL6524Driver* const pcal6524d, const pcal6524_lld_cmd_t reg, uint8_t* const data, const apalTime_t timeout)
+apalExitStatus_t pcal6524_lld_read_group(const PCAL6524Driver* const pcal6524d, const pcal6524_lld_cmd_t reg, uint8_t* const data, const apalTime_t timeout)
 {
   apalDbgAssert(pcal6524d != NULL && pcal6524d->i2cd != NULL);
   apalDbgAssert(data != NULL);
@@ -223,8 +219,7 @@ pcal6524_lld_read_group(const PCAL6524Driver* const pcal6524d, const pcal6524_ll
  *
  * @return    Indicator whether the function call was successful or a timeout occurred.
  */
-inline apalExitStatus_t
-pcal6524_lld_write_group(const PCAL6524Driver* const pcal6524d, const pcal6524_lld_cmd_t reg, const uint8_t* const data, const apalTime_t timeout)
+apalExitStatus_t pcal6524_lld_write_group(const PCAL6524Driver* const pcal6524d, const pcal6524_lld_cmd_t reg, const uint8_t* const data, const apalTime_t timeout)
 {
   apalDbgAssert(pcal6524d != NULL && pcal6524d->i2cd != NULL);
   apalDbgAssert(data != NULL);
@@ -245,8 +240,7 @@ pcal6524_lld_write_group(const PCAL6524Driver* const pcal6524d, const pcal6524_l
  *
  * @return    Indicator whether the function call was successful or a timeout occurred.
  */
-inline apalExitStatus_t
-pcal6524_lld_read_continuous(const PCAL6524Driver* const pcal6524d, const pcal6524_lld_cmd_t reg, uint8_t* const data, const uint8_t length, const apalTime_t timeout)
+apalExitStatus_t pcal6524_lld_read_continuous(const PCAL6524Driver* const pcal6524d, const pcal6524_lld_cmd_t reg, uint8_t* const data, const uint8_t length, const apalTime_t timeout)
 {
   apalDbgAssert(pcal6524d != NULL && pcal6524d->i2cd != NULL);
   apalDbgAssert(data != NULL);
@@ -267,8 +261,7 @@ pcal6524_lld_read_continuous(const PCAL6524Driver* const pcal6524d, const pcal65
  *
  * @return    Indicator whether the function call was successful or a timeout occurred.
  */
-inline apalExitStatus_t
-pcal6524_lld_write_continuous(const PCAL6524Driver* const pcal6524d, const pcal6524_lld_cmd_t reg, const uint8_t* const data, const uint8_t length, const apalTime_t timeout)
+apalExitStatus_t pcal6524_lld_write_continuous(const PCAL6524Driver* const pcal6524d, const pcal6524_lld_cmd_t reg, const uint8_t* const data, const uint8_t length, const apalTime_t timeout)
 {
   apalDbgAssert(pcal6524d != NULL && pcal6524d->i2cd != NULL);
   apalDbgAssert(data != NULL);