commit 21076167d7a67dc33ba671ce89b36f1be9ef2e51
Author: Thomas Schöpping <tschoepp@cit-ec.uni-bielefeld.de>
Date:   Mon Feb 4 17:36:52 2019 +0100

    Applied minor enhancements to all drivers.
    Please note: multiple functions should (and will) be moved from the .c sources to the header files as inline functions soon.

diff --git a/source/alld_vcnl4020.c b/source/alld_vcnl4020.c
index 0517788..fef09f5 100644
--- a/source/alld_vcnl4020.c
+++ b/source/alld_vcnl4020.c
@@ -63,8 +63,7 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  *
  * @return  The return status indicates whether the function call was succesfull or a timeout occurred.
  */
-inline apalExitStatus_t
-vcnl4020_lld_readreg(const VCNL4020Driver* const vcnld, const vcnl4020_lld_regaddr_t reg, uint8_t* const data, const apalTime_t timeout)
+apalExitStatus_t vcnl4020_lld_readreg(const VCNL4020Driver* const vcnld, const vcnl4020_lld_regaddr_t reg, uint8_t* const data, const apalTime_t timeout)
 {
   apalDbgAssert(vcnld != NULL && vcnld->i2cd != NULL);
   apalDbgAssert(data != NULL);
@@ -81,8 +80,7 @@ vcnl4020_lld_readreg(const VCNL4020Driver* const vcnld, const vcnl4020_lld_regad
  *
  * @return  The return status indicates whether the function call was succesfull or a timeout occurred.
  */
-inline apalExitStatus_t
-vcnl4020_lld_writereg(const VCNL4020Driver* const vcnld, const vcnl4020_lld_regaddr_t reg, const uint8_t data, const apalTime_t timeout)
+apalExitStatus_t vcnl4020_lld_writereg(const VCNL4020Driver* const vcnld, const vcnl4020_lld_regaddr_t reg, const uint8_t data, const apalTime_t timeout)
 {
   apalDbgAssert(vcnld != NULL && vcnld->i2cd != NULL);
 
@@ -101,8 +99,7 @@ vcnl4020_lld_writereg(const VCNL4020Driver* const vcnld, const vcnl4020_lld_rega
  *
  * @return  The return status indicates whether the function call was succesfull or a timeout occurred.
  */
-inline apalExitStatus_t
-vcnl4020_lld_readals(const VCNL4020Driver* const vcnld, uint16_t* const als, const apalTime_t timeout)
+apalExitStatus_t vcnl4020_lld_readals(const VCNL4020Driver* const vcnld, uint16_t* const als, const apalTime_t timeout)
 {
   apalDbgAssert(vcnld != NULL && vcnld->i2cd != NULL);
   apalDbgAssert(als != NULL);
@@ -123,8 +120,7 @@ vcnl4020_lld_readals(const VCNL4020Driver* const vcnld, uint16_t* const als, con
  *
  * @return  The return status indicates whether the function call was succesfull or a timeout occurred.
  */
-inline apalExitStatus_t
-vcnl4020_lld_readprox(const VCNL4020Driver* const vcnld, uint16_t* const prox, const apalTime_t timeout)
+apalExitStatus_t vcnl4020_lld_readprox(const VCNL4020Driver* const vcnld, uint16_t* const prox, const apalTime_t timeout)
 {
   apalDbgAssert(vcnld != NULL && vcnld->i2cd != NULL);
   apalDbgAssert(prox != NULL);
@@ -146,8 +142,7 @@ vcnl4020_lld_readprox(const VCNL4020Driver* const vcnld, uint16_t* const prox, c
  *
  * @return  The return status indicates whether the function call was succesfull or a timeout occurred.
  */
-inline apalExitStatus_t
-vcnl4020_lld_readalsandprox(const VCNL4020Driver* const vcnld, uint16_t* const als, uint16_t* const prox, const apalTime_t timeout)
+apalExitStatus_t vcnl4020_lld_readalsandprox(const VCNL4020Driver* const vcnld, uint16_t* const als, uint16_t* const prox, const apalTime_t timeout)
 {
   apalDbgAssert(vcnld != NULL && vcnld->i2cd != NULL);
   apalDbgAssert(als != NULL);
@@ -174,8 +169,7 @@ vcnl4020_lld_readalsandprox(const VCNL4020Driver* const vcnld, uint16_t* const a
  *
  * @return  The return status indicates whether the function call was succesfull or a timeout occurred.
  */
-inline apalExitStatus_t
-vcnl4020_lld_readlth(const VCNL4020Driver* const vcnld, uint16_t* const th, const apalTime_t timeout)
+apalExitStatus_t vcnl4020_lld_readlth(const VCNL4020Driver* const vcnld, uint16_t* const th, const apalTime_t timeout)
 {
   apalDbgAssert(vcnld != NULL && vcnld->i2cd != NULL);
   apalDbgAssert(th != NULL);
@@ -196,8 +190,7 @@ vcnl4020_lld_readlth(const VCNL4020Driver* const vcnld, uint16_t* const th, cons
  *
  * @return  The return status indicates whether the function call was succesfull or a timeout occurred.
  */
-inline apalExitStatus_t
-vcnl4020_lld_readhth(const VCNL4020Driver* const vcnld, uint16_t* const th, const apalTime_t timeout)
+apalExitStatus_t vcnl4020_lld_readhth(const VCNL4020Driver* const vcnld, uint16_t* const th, const apalTime_t timeout)
 {
   apalDbgAssert(vcnld != NULL && vcnld->i2cd != NULL);
   apalDbgAssert(th != NULL);
@@ -219,8 +212,7 @@ vcnl4020_lld_readhth(const VCNL4020Driver* const vcnld, uint16_t* const th, cons
  *
  * @return  The return status indicates whether the function call was succesfull or a timeout occurred.
  */
-inline apalExitStatus_t
-vcnl4020_lld_readth(const VCNL4020Driver* const vcnld, uint16_t* const lth, uint16_t* const hth, const apalTime_t timeout)
+apalExitStatus_t vcnl4020_lld_readth(const VCNL4020Driver* const vcnld, uint16_t* const lth, uint16_t* const hth, const apalTime_t timeout)
 {
   apalDbgAssert(vcnld != NULL && vcnld->i2cd != NULL);
   apalDbgAssert(lth != NULL);
@@ -243,8 +235,7 @@ vcnl4020_lld_readth(const VCNL4020Driver* const vcnld, uint16_t* const lth, uint
  *
  * @return  The return status indicates whether the function call was succesfull or a timeout occurred.
  */
-inline apalExitStatus_t
-vcnl4020_lld_writelth(const VCNL4020Driver* const vcnld, const uint16_t th, const apalTime_t timeout)
+apalExitStatus_t vcnl4020_lld_writelth(const VCNL4020Driver* const vcnld, const uint16_t th, const apalTime_t timeout)
 {
   apalDbgAssert(vcnld != NULL && vcnld->i2cd != NULL);
 
@@ -261,8 +252,7 @@ vcnl4020_lld_writelth(const VCNL4020Driver* const vcnld, const uint16_t th, cons
  *
  * @return  The return status indicates whether the function call was succesfull or a timeout occurred.
  */
-inline apalExitStatus_t
-vcnl4020_lld_writehth(const VCNL4020Driver* const vcnld, const uint16_t th, const apalTime_t timeout)
+apalExitStatus_t vcnl4020_lld_writehth(const VCNL4020Driver* const vcnld, const uint16_t th, const apalTime_t timeout)
 {
   apalDbgAssert(vcnld != NULL && vcnld->i2cd != NULL);
 
@@ -280,8 +270,7 @@ vcnl4020_lld_writehth(const VCNL4020Driver* const vcnld, const uint16_t th, cons
  *
  * @return  The return status indicates whether the function call was succesfull or a timeout occurred.
  */
-inline apalExitStatus_t
-vcnl4020_lld_writeth(const VCNL4020Driver* const vcnld, const uint16_t lth, const uint16_t hth, const apalTime_t timeout)
+apalExitStatus_t vcnl4020_lld_writeth(const VCNL4020Driver* const vcnld, const uint16_t lth, const uint16_t hth, const apalTime_t timeout)
 {
   apalDbgAssert(vcnld != NULL && vcnld->i2cd != NULL);
 